type token =
  | IDENTIFIER of (string)
  | CONSTANT of (Jc_ast.const)
  | STRING_LITERAL of (string)
  | NULL
  | LPAR
  | RPAR
  | LPARRPAR
  | LBRACE
  | RBRACE
  | LSQUARE
  | RSQUARE
  | DOTDOT
  | SEMICOLON
  | COMMA
  | COLON
  | DOT
  | QUESTION
  | MINUS
  | MINUSMINUS
  | PLUS
  | PLUSPLUS
  | STAR
  | SLASH
  | PERCENT
  | EQ
  | LTEQ
  | GTEQ
  | GT
  | LT
  | EQEQ
  | BANGEQ
  | LTCOLON
  | COLONGT
  | PLUSEQ
  | MINUSEQ
  | STAREQ
  | SLASHEQ
  | PERCENTEQ
  | AMPAMP
  | BARBAR
  | EQGT
  | LTEQGT
  | EXCLAM
  | IF
  | ELSE
  | RETURN
  | WHILE
  | BREAK
  | CASE
  | SWITCH
  | DEFAULT
  | EXCEPTION
  | OF
  | THROW
  | TRY
  | CATCH
  | PACK
  | UNPACK
  | ASSERT
  | TYPE
  | INVARIANT
  | LOGIC
  | WITH
  | VARIANT
  | AND
  | INTEGER
  | BOOLEAN
  | REAL
  | UNIT
  | ASSIGNS
  | ASSUMES
  | BEHAVIOR
  | ENSURES
  | REQUIRES
  | THROWS
  | BSFORALL
  | BSOFFSET_MAX
  | BSOFFSET_MIN
  | BSOLD
  | BSRESULT
  | BSNOTHING
  | AXIOM
  | EOF

open Parsing;;
# 28 "jc/jc_parser.mly"

  open Format
  open Jc_env
  open Jc_ast
  open Jc_pervasives
  open Parsing
  open Error

  let loc () = (symbol_start_pos (), symbol_end_pos ())
  let loc_i i = (rhs_start_pos i, rhs_end_pos i)

  let locate_type e =
    { jc_ptype_node = e ; jc_ptype_loc = loc () }

  let locate_expr e =
    { jc_pexpr_node = e ; jc_pexpr_loc = loc () }

  let locate_statement s =
    { jc_pstatement_node = s ; jc_pstatement_loc = loc () }

  let locate_decl d =
    { jc_pdecl_node = d ; jc_pdecl_loc = loc () }


(*
  let locate x = { node = x; loc = loc() }
  let locate_i i x = { node = x; loc = loc_i i }
  let with_loc l x = { node = x; loc = l }
*)

  let skip = locate_statement JCPSskip
      

# 122 "jc/jc_parser.ml"
let yytransl_const = [|
  260 (* NULL *);
  261 (* LPAR *);
  262 (* RPAR *);
  263 (* LPARRPAR *);
  264 (* LBRACE *);
  265 (* RBRACE *);
  266 (* LSQUARE *);
  267 (* RSQUARE *);
  268 (* DOTDOT *);
  269 (* SEMICOLON *);
  270 (* COMMA *);
  271 (* COLON *);
  272 (* DOT *);
  273 (* QUESTION *);
  274 (* MINUS *);
  275 (* MINUSMINUS *);
  276 (* PLUS *);
  277 (* PLUSPLUS *);
  278 (* STAR *);
  279 (* SLASH *);
  280 (* PERCENT *);
  281 (* EQ *);
  282 (* LTEQ *);
  283 (* GTEQ *);
  284 (* GT *);
  285 (* LT *);
  286 (* EQEQ *);
  287 (* BANGEQ *);
  288 (* LTCOLON *);
  289 (* COLONGT *);
  290 (* PLUSEQ *);
  291 (* MINUSEQ *);
  292 (* STAREQ *);
  293 (* SLASHEQ *);
  294 (* PERCENTEQ *);
  295 (* AMPAMP *);
  296 (* BARBAR *);
  297 (* EQGT *);
  298 (* LTEQGT *);
  299 (* EXCLAM *);
  300 (* IF *);
  301 (* ELSE *);
  302 (* RETURN *);
  303 (* WHILE *);
  304 (* BREAK *);
  305 (* CASE *);
  306 (* SWITCH *);
  307 (* DEFAULT *);
  308 (* EXCEPTION *);
  309 (* OF *);
  310 (* THROW *);
  311 (* TRY *);
  312 (* CATCH *);
  313 (* PACK *);
  314 (* UNPACK *);
  315 (* ASSERT *);
  316 (* TYPE *);
  317 (* INVARIANT *);
  318 (* LOGIC *);
  319 (* WITH *);
  320 (* VARIANT *);
  321 (* AND *);
  322 (* INTEGER *);
  323 (* BOOLEAN *);
  324 (* REAL *);
  325 (* UNIT *);
  326 (* ASSIGNS *);
  327 (* ASSUMES *);
  328 (* BEHAVIOR *);
  329 (* ENSURES *);
  330 (* REQUIRES *);
  331 (* THROWS *);
  332 (* BSFORALL *);
  333 (* BSOFFSET_MAX *);
  334 (* BSOFFSET_MIN *);
  335 (* BSOLD *);
  336 (* BSRESULT *);
  337 (* BSNOTHING *);
  338 (* AXIOM *);
    0 (* EOF *);
    0|]

let yytransl_block = [|
  257 (* IDENTIFIER *);
  258 (* CONSTANT *);
  259 (* STRING_LITERAL *);
    0|]

let yylhs = "\255\255\
\001\000\001\000\001\000\003\000\002\000\002\000\002\000\002\000\
\002\000\004\000\004\000\006\000\006\000\006\000\010\000\010\000\
\011\000\011\000\012\000\012\000\012\000\013\000\014\000\017\000\
\017\000\017\000\018\000\018\000\019\000\015\000\015\000\015\000\
\015\000\015\000\015\000\015\000\015\000\015\000\015\000\020\000\
\020\000\021\000\021\000\022\000\022\000\023\000\023\000\024\000\
\024\000\024\000\005\000\007\000\008\000\028\000\028\000\028\000\
\028\000\028\000\028\000\029\000\029\000\029\000\029\000\029\000\
\029\000\029\000\029\000\029\000\029\000\029\000\029\000\029\000\
\029\000\026\000\026\000\030\000\030\000\030\000\030\000\031\000\
\031\000\031\000\032\000\033\000\033\000\033\000\033\000\033\000\
\033\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\016\000\016\000\016\000\016\000\016\000\016\000\016\000\
\016\000\034\000\034\000\025\000\035\000\035\000\036\000\038\000\
\039\000\039\000\040\000\040\000\027\000\037\000\037\000\042\000\
\042\000\042\000\043\000\043\000\043\000\044\000\045\000\046\000\
\046\000\047\000\047\000\041\000\041\000\041\000\041\000\041\000\
\041\000\041\000\041\000\048\000\048\000\009\000\009\000\000\000"

let yylen = "\002\000\
\002\000\002\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\003\000\003\000\006\000\007\000\003\000\001\000\002\000\
\000\000\002\000\000\000\002\000\002\000\003\000\008\000\001\000\
\002\000\003\000\001\000\003\000\002\000\001\000\001\000\001\000\
\001\000\001\000\004\000\004\000\005\000\006\000\005\000\000\000\
\002\000\003\000\009\000\000\000\003\000\000\000\003\000\000\000\
\003\000\003\000\005\000\004\000\004\000\001\000\001\000\001\000\
\001\000\001\000\003\000\001\000\003\000\004\000\004\000\004\000\
\004\000\003\000\002\000\002\000\002\000\002\000\002\000\002\000\
\002\000\001\000\003\000\001\000\003\000\003\000\003\000\001\000\
\003\000\003\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\005\000\003\000\005\000\003\000\
\003\000\001\000\003\000\001\000\003\000\005\000\004\000\003\000\
\000\000\002\000\002\000\001\000\003\000\000\000\002\000\001\000\
\002\000\003\000\005\000\007\000\007\000\004\000\006\000\002\000\
\003\000\005\000\005\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\004\000\006\000\006\000\005\000\002\000"

let yydefred = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\030\000\031\000\
\032\000\033\000\000\000\003\000\144\000\000\000\000\000\004\000\
\005\000\000\000\007\000\008\000\009\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\001\000\002\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\024\000\000\000\
\014\000\000\000\000\000\000\000\010\000\000\000\000\000\036\000\
\000\000\000\000\035\000\053\000\000\000\015\000\000\000\000\000\
\000\000\025\000\000\000\000\000\000\000\000\000\000\000\054\000\
\056\000\058\000\000\000\057\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\055\000\000\000\000\000\
\000\000\000\000\000\000\090\000\000\000\000\000\000\000\000\000\
\000\000\037\000\039\000\018\000\016\000\000\000\000\000\029\000\
\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\068\000\067\000\084\000\
\085\000\086\000\087\000\088\000\089\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\051\000\041\000\
\038\000\012\000\000\000\000\000\000\000\000\000\000\000\028\000\
\000\000\059\000\000\000\000\000\000\000\000\000\000\000\000\000\
\093\000\094\000\092\000\091\000\097\000\098\000\095\000\096\000\
\000\000\000\000\000\000\000\000\061\000\000\000\000\000\066\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\042\000\000\000\120\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\132\000\
\137\000\000\000\000\000\133\000\134\000\135\000\136\000\138\000\
\139\000\000\000\013\000\020\000\021\000\000\000\000\000\000\000\
\064\000\065\000\063\000\000\000\000\000\062\000\000\000\000\000\
\000\000\000\000\000\000\128\000\000\000\108\000\000\000\000\000\
\000\000\000\000\000\000\000\000\121\000\117\000\119\000\000\000\
\022\000\107\000\000\000\000\000\075\000\000\000\000\000\000\000\
\000\000\129\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\122\000\109\000\000\000\000\000\045\000\000\000\000\000\
\000\000\000\000\000\000\126\000\000\000\140\000\000\000\000\000\
\000\000\000\000\000\000\047\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\130\000\131\000\110\000\000\000\050\000\
\049\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\141\000\000\000\043\000\124\000\000\000\000\000\114\000\000\000\
\115\000\125\000\023\000\127\000\000\000\000\000\111\000\112\000"

let yydgoto = "\002\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\056\000\057\000\148\000\149\000\150\000\198\000\199\000\
\040\000\060\000\061\000\087\000\088\000\224\000\248\000\009\001\
\231\000\175\000\200\000\080\000\081\000\082\000\083\000\084\000\
\134\000\156\000\201\000\038\001\202\000\049\001\039\001\040\001\
\203\000\204\000\205\000\206\000\252\000\207\000\208\000\209\000"

let yysindex = "\013\000\
\032\003\000\000\034\255\059\255\089\255\045\255\000\000\000\000\
\000\000\000\000\123\255\000\000\000\000\032\003\032\003\000\000\
\000\000\230\254\000\000\000\000\000\000\126\255\001\255\048\255\
\111\255\052\255\138\255\164\255\091\255\000\000\000\000\004\255\
\159\255\105\255\027\255\109\255\010\255\066\255\000\000\148\255\
\000\000\159\255\127\005\119\255\000\000\230\254\100\255\000\000\
\029\255\176\255\000\000\000\000\129\255\000\000\187\255\183\255\
\197\255\000\000\212\255\208\255\201\255\127\005\192\255\000\000\
\000\000\000\000\127\005\000\000\207\005\207\005\207\005\207\005\
\207\005\109\255\213\255\214\255\215\255\000\000\201\001\216\255\
\172\255\046\255\162\255\000\000\223\255\127\005\218\255\100\255\
\211\255\000\000\000\000\000\000\000\000\007\255\102\255\000\000\
\000\000\109\255\201\001\127\005\002\001\224\255\224\255\224\255\
\224\255\224\255\226\255\127\005\127\005\127\005\127\005\127\005\
\127\005\127\005\127\005\127\005\127\005\227\255\229\255\127\005\
\127\005\127\005\127\005\124\255\230\255\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\127\005\207\005\207\005\
\207\005\207\005\207\005\228\255\240\004\117\005\000\000\000\000\
\000\000\000\000\240\255\233\255\102\255\102\255\248\255\000\000\
\201\001\000\000\236\255\238\255\026\003\034\005\016\006\099\007\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\120\255\089\000\073\002\201\001\000\000\080\007\247\255\000\000\
\019\000\081\255\081\255\081\255\081\255\046\255\046\255\179\255\
\000\000\034\255\000\000\250\255\127\005\127\005\243\255\254\255\
\003\000\117\005\004\000\005\000\127\005\007\000\127\006\000\000\
\000\000\252\255\117\005\000\000\000\000\000\000\000\000\000\000\
\000\000\049\000\000\000\000\000\000\000\249\255\226\255\127\005\
\000\000\000\000\000\000\127\005\127\005\000\000\003\000\198\255\
\127\005\148\006\206\255\000\000\127\005\000\000\127\005\255\255\
\127\005\127\005\169\006\005\255\000\000\000\000\000\000\055\000\
\000\000\000\000\201\001\019\000\000\000\044\000\127\005\246\255\
\033\006\000\000\127\005\117\005\061\006\190\006\003\000\078\006\
\106\006\000\000\000\000\127\005\006\000\000\000\211\006\015\255\
\002\000\117\005\232\006\000\000\056\000\000\000\064\000\053\000\
\058\000\253\006\048\000\000\000\061\000\063\000\127\005\033\000\
\015\000\031\000\117\005\000\000\000\000\000\000\127\005\000\000\
\000\000\018\007\117\005\127\005\079\000\031\000\036\000\073\000\
\000\000\039\007\000\000\000\000\060\007\075\000\000\000\077\000\
\000\000\000\000\000\000\000\000\117\005\117\005\000\000\000\000"

let yyrindex = "\000\000\
\000\000\000\000\169\003\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\229\003\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\123\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\117\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\165\004\118\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\121\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\183\004\001\000\
\184\001\195\002\146\003\000\000\000\000\000\000\000\000\118\000\
\000\000\000\000\000\000\000\000\000\000\000\000\120\000\000\000\
\000\000\000\000\194\004\000\000\000\000\071\000\141\000\211\000\
\044\001\114\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\125\000\000\000\000\000\
\000\000\000\000\000\000\000\000\120\000\120\000\000\000\000\000\
\223\004\000\000\122\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\203\003\004\004\110\004\136\004\000\000\036\255\000\000\000\000\
\046\004\254\001\055\002\125\002\184\001\009\003\089\003\067\255\
\000\000\235\005\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\012\255\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\190\254\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\154\004\079\004\000\000\000\000\000\000\057\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\037\005\
\000\000\253\254\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\253\254\127\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\012\255\125\000\000\000\000\000"

let yygindex = "\000\000\
\142\000\000\000\000\000\109\001\000\000\111\001\000\000\000\000\
\000\000\050\001\000\000\011\000\000\000\000\000\009\000\221\255\
\008\000\047\001\000\000\058\001\000\000\000\000\000\000\000\000\
\038\255\035\255\061\001\000\000\239\255\045\000\000\000\000\000\
\000\000\190\000\000\000\000\000\055\255\000\000\112\000\000\000\
\088\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000"

let yytablesize = 2189
let yytable = "\245\000\
\060\000\239\000\034\000\046\000\246\000\113\000\046\000\079\000\
\054\000\022\000\053\000\054\000\035\000\001\000\028\000\064\000\
\065\000\003\001\066\000\067\000\118\000\068\000\022\000\022\000\
\055\000\232\000\099\000\055\000\050\000\004\001\089\000\101\000\
\069\000\070\000\071\000\072\000\015\001\051\000\032\000\090\000\
\047\000\074\000\022\001\023\000\052\000\026\000\059\000\113\000\
\074\000\063\000\141\000\102\000\103\000\104\000\105\000\106\000\
\038\000\073\000\039\000\024\000\118\000\023\000\118\000\005\000\
\153\000\044\000\003\000\135\000\136\000\137\000\072\000\058\000\
\157\000\158\000\159\000\160\000\161\000\162\000\163\000\164\000\
\165\000\166\000\107\000\012\001\169\000\170\000\171\000\172\000\
\174\000\025\000\074\000\075\000\076\000\077\000\078\000\021\001\
\125\000\024\001\177\000\126\000\036\000\127\000\003\000\151\000\
\027\000\043\000\059\000\055\001\056\001\003\000\007\000\008\000\
\009\000\010\000\041\001\048\000\049\000\178\000\179\000\180\000\
\181\000\181\000\044\001\029\000\064\000\065\000\033\000\066\000\
\067\000\173\000\068\000\007\000\008\000\009\000\010\000\037\000\
\044\000\044\000\041\000\044\000\070\000\069\000\070\000\071\000\
\072\000\112\000\113\000\114\000\115\000\116\000\117\000\118\000\
\119\000\226\000\227\000\030\000\031\000\151\000\151\000\212\000\
\213\000\235\000\147\000\038\000\042\000\039\000\073\000\007\000\
\008\000\009\000\010\000\085\000\062\000\086\000\007\000\008\000\
\009\000\010\000\027\000\138\000\243\000\139\000\182\000\183\000\
\244\000\174\000\091\000\125\000\093\000\249\000\126\000\092\000\
\127\000\253\000\094\000\254\000\128\000\000\001\001\001\074\000\
\075\000\076\000\077\000\078\000\095\000\129\000\130\000\131\000\
\132\000\133\000\071\000\007\001\096\000\097\000\098\000\011\001\
\100\000\108\000\109\000\110\000\124\000\145\000\111\000\140\000\
\018\001\142\000\155\000\167\000\174\000\168\000\176\000\112\000\
\113\000\114\000\115\000\116\000\117\000\118\000\119\000\125\000\
\210\000\211\000\184\000\034\001\120\000\121\000\122\000\123\000\
\214\000\215\000\216\000\042\001\222\000\223\000\225\000\228\000\
\045\001\060\000\229\000\230\000\238\000\241\000\060\000\236\000\
\233\000\234\000\251\000\019\001\247\000\060\000\060\000\060\000\
\060\000\060\000\060\000\060\000\060\000\060\000\060\000\060\000\
\060\000\060\000\060\000\060\000\060\000\060\000\060\000\060\000\
\060\000\060\000\060\000\060\000\060\000\060\000\060\000\060\000\
\060\000\060\000\060\000\069\000\112\000\113\000\114\000\115\000\
\116\000\117\000\118\000\119\000\060\000\240\000\255\000\005\001\
\006\001\120\000\121\000\008\001\060\000\060\000\060\000\026\001\
\027\001\028\001\060\000\060\000\060\000\060\000\029\001\072\000\
\031\001\032\001\023\001\033\001\072\000\035\001\036\001\037\001\
\046\001\050\001\060\000\072\000\072\000\072\000\048\001\072\000\
\072\000\053\001\072\000\054\001\072\000\072\000\072\000\072\000\
\072\000\072\000\072\000\072\000\072\000\072\000\072\000\072\000\
\072\000\072\000\072\000\072\000\072\000\072\000\072\000\072\000\
\072\000\073\000\112\000\113\000\114\000\115\000\116\000\117\000\
\118\000\119\000\072\000\034\000\017\000\040\000\027\000\120\000\
\019\000\048\000\072\000\072\000\072\000\118\000\106\000\116\000\
\072\000\072\000\072\000\072\000\045\000\070\000\046\000\146\000\
\152\000\144\000\070\000\143\000\242\000\047\001\000\000\000\000\
\072\000\070\000\070\000\070\000\000\000\070\000\070\000\000\000\
\070\000\000\000\070\000\070\000\070\000\070\000\070\000\070\000\
\070\000\070\000\070\000\070\000\070\000\070\000\070\000\070\000\
\070\000\070\000\070\000\070\000\070\000\070\000\070\000\076\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\070\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\070\000\070\000\070\000\000\000\000\000\000\000\070\000\070\000\
\070\000\070\000\000\000\071\000\000\000\000\000\000\000\000\000\
\071\000\000\000\000\000\000\000\000\000\000\000\070\000\071\000\
\071\000\071\000\000\000\071\000\071\000\000\000\071\000\000\000\
\071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
\071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
\071\000\071\000\071\000\071\000\071\000\077\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\071\000\154\000\
\000\000\000\000\000\000\000\000\000\000\000\000\071\000\071\000\
\071\000\000\000\111\000\000\000\071\000\071\000\071\000\071\000\
\000\000\000\000\000\000\112\000\113\000\114\000\115\000\116\000\
\117\000\118\000\119\000\000\000\071\000\000\000\000\000\000\000\
\120\000\121\000\122\000\123\000\069\000\000\000\000\000\000\000\
\000\000\069\000\000\000\000\000\000\000\000\000\078\000\000\000\
\069\000\069\000\069\000\000\000\069\000\069\000\000\000\069\000\
\000\000\069\000\069\000\069\000\069\000\069\000\069\000\069\000\
\069\000\069\000\069\000\069\000\069\000\069\000\069\000\069\000\
\069\000\069\000\069\000\069\000\069\000\069\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\069\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\069\000\
\069\000\069\000\000\000\000\000\000\000\069\000\069\000\069\000\
\069\000\000\000\073\000\000\000\000\000\000\000\000\000\073\000\
\000\000\000\000\000\000\000\000\079\000\069\000\073\000\073\000\
\073\000\000\000\073\000\073\000\000\000\073\000\000\000\073\000\
\073\000\073\000\073\000\073\000\073\000\073\000\073\000\073\000\
\073\000\073\000\073\000\073\000\073\000\073\000\073\000\073\000\
\073\000\073\000\073\000\073\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\073\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\073\000\073\000\073\000\
\000\000\000\000\000\000\073\000\073\000\073\000\073\000\000\000\
\076\000\000\000\000\000\000\000\000\000\076\000\000\000\000\000\
\000\000\000\000\080\000\073\000\076\000\076\000\076\000\000\000\
\076\000\076\000\000\000\076\000\000\000\076\000\076\000\076\000\
\000\000\076\000\076\000\076\000\076\000\076\000\076\000\076\000\
\076\000\111\000\000\000\000\000\000\000\000\000\076\000\076\000\
\076\000\076\000\112\000\113\000\114\000\115\000\116\000\117\000\
\118\000\119\000\000\000\076\000\000\000\000\000\000\000\120\000\
\121\000\122\000\123\000\076\000\076\000\076\000\000\000\000\000\
\000\000\076\000\076\000\076\000\076\000\000\000\077\000\000\000\
\000\000\000\000\000\000\077\000\000\000\000\000\000\000\000\000\
\082\000\076\000\077\000\077\000\077\000\000\000\077\000\077\000\
\000\000\077\000\000\000\077\000\077\000\077\000\000\000\077\000\
\077\000\077\000\077\000\077\000\077\000\077\000\077\000\012\000\
\000\000\000\000\000\000\000\000\077\000\077\000\077\000\077\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\077\000\000\000\000\000\000\000\000\000\000\000\078\000\
\000\000\077\000\077\000\077\000\078\000\000\000\000\000\077\000\
\077\000\077\000\077\000\078\000\078\000\078\000\000\000\078\000\
\078\000\000\000\078\000\000\000\078\000\078\000\078\000\077\000\
\078\000\078\000\078\000\078\000\078\000\078\000\078\000\078\000\
\081\000\111\000\000\000\000\000\000\000\078\000\078\000\078\000\
\078\000\000\000\112\000\113\000\114\000\115\000\116\000\117\000\
\118\000\119\000\078\000\000\000\000\000\000\000\000\000\120\000\
\121\000\122\000\078\000\078\000\078\000\000\000\000\000\000\000\
\078\000\078\000\078\000\078\000\000\000\079\000\000\000\000\000\
\000\000\000\000\079\000\000\000\000\000\000\000\000\000\000\000\
\078\000\079\000\079\000\079\000\000\000\079\000\079\000\000\000\
\079\000\083\000\079\000\079\000\079\000\000\000\079\000\079\000\
\079\000\079\000\079\000\079\000\079\000\079\000\000\000\000\000\
\000\000\000\000\000\000\079\000\079\000\079\000\079\000\000\000\
\034\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\079\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\079\000\079\000\079\000\000\000\000\000\000\000\079\000\079\000\
\079\000\079\000\000\000\080\000\000\000\000\000\000\000\000\000\
\080\000\000\000\099\000\000\000\000\000\000\000\079\000\080\000\
\080\000\080\000\000\000\080\000\080\000\000\000\080\000\000\000\
\000\000\000\000\000\000\000\000\080\000\080\000\080\000\080\000\
\080\000\080\000\080\000\080\000\006\000\000\000\000\000\000\000\
\000\000\080\000\080\000\080\000\080\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\080\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\080\000\080\000\
\080\000\000\000\000\000\100\000\080\000\080\000\080\000\080\000\
\000\000\082\000\000\000\000\000\000\000\000\000\082\000\000\000\
\000\000\000\000\000\000\000\000\080\000\082\000\082\000\082\000\
\000\000\082\000\082\000\000\000\082\000\000\000\000\000\217\000\
\003\000\000\000\082\000\082\000\082\000\082\000\082\000\082\000\
\082\000\082\000\111\000\000\000\000\000\102\000\000\000\082\000\
\082\000\082\000\082\000\112\000\113\000\114\000\115\000\116\000\
\117\000\118\000\119\000\000\000\082\000\000\000\000\000\000\000\
\120\000\121\000\122\000\123\000\082\000\082\000\082\000\000\000\
\000\000\000\000\082\000\082\000\082\000\082\000\101\000\000\000\
\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\
\000\000\081\000\082\000\005\000\000\000\006\000\081\000\000\000\
\000\000\007\000\008\000\009\000\010\000\081\000\081\000\081\000\
\000\000\081\000\081\000\000\000\081\000\104\000\000\000\000\000\
\000\000\011\000\081\000\081\000\081\000\081\000\081\000\081\000\
\081\000\081\000\000\000\000\000\000\000\000\000\000\000\081\000\
\081\000\081\000\081\000\000\000\000\000\000\000\000\000\105\000\
\000\000\000\000\000\000\000\000\081\000\000\000\000\000\000\000\
\000\000\000\000\083\000\000\000\081\000\081\000\081\000\083\000\
\000\000\103\000\081\000\081\000\081\000\081\000\083\000\083\000\
\083\000\000\000\083\000\000\000\011\000\000\000\000\000\000\000\
\000\000\034\000\081\000\083\000\083\000\083\000\083\000\083\000\
\083\000\083\000\083\000\000\000\000\000\000\000\052\000\000\000\
\083\000\083\000\083\000\083\000\000\000\000\000\000\000\000\000\
\000\000\143\000\000\000\000\000\000\000\083\000\000\000\000\000\
\000\000\000\000\000\000\099\000\000\000\083\000\083\000\083\000\
\099\000\000\000\000\000\083\000\083\000\083\000\083\000\099\000\
\099\000\099\000\000\000\099\000\034\000\000\000\142\000\000\000\
\000\000\000\000\000\000\083\000\034\000\006\000\034\000\000\000\
\000\000\000\000\034\000\034\000\034\000\034\000\000\000\000\000\
\000\000\099\000\099\000\099\000\099\000\000\000\000\000\000\000\
\000\000\000\000\034\000\000\000\000\000\000\000\099\000\000\000\
\000\000\000\000\000\000\000\000\100\000\000\000\099\000\099\000\
\099\000\100\000\000\000\000\000\099\000\099\000\099\000\099\000\
\100\000\100\000\100\000\000\000\100\000\000\000\000\000\000\000\
\006\000\000\000\000\000\000\000\099\000\000\000\000\000\000\000\
\006\000\000\000\006\000\000\000\000\000\000\000\006\000\006\000\
\006\000\006\000\000\000\100\000\100\000\100\000\102\000\000\000\
\000\000\000\000\000\000\102\000\000\000\000\000\006\000\100\000\
\000\000\000\000\102\000\102\000\102\000\000\000\102\000\100\000\
\100\000\100\000\000\000\000\000\000\000\100\000\100\000\100\000\
\100\000\000\000\000\000\000\000\000\000\000\000\000\000\101\000\
\000\000\000\000\000\000\000\000\101\000\100\000\102\000\102\000\
\000\000\000\000\000\000\101\000\101\000\101\000\000\000\101\000\
\000\000\102\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\102\000\102\000\102\000\000\000\000\000\104\000\102\000\
\102\000\102\000\102\000\104\000\000\000\000\000\000\000\101\000\
\101\000\000\000\104\000\104\000\104\000\000\000\000\000\102\000\
\000\000\000\000\101\000\000\000\000\000\000\000\000\000\000\000\
\105\000\000\000\101\000\101\000\101\000\105\000\000\000\000\000\
\101\000\101\000\101\000\101\000\105\000\105\000\105\000\104\000\
\000\000\000\000\103\000\000\000\000\000\000\000\000\000\103\000\
\101\000\104\000\000\000\000\000\000\000\011\000\103\000\103\000\
\103\000\104\000\104\000\104\000\000\000\000\000\000\000\104\000\
\104\000\104\000\104\000\000\000\000\000\000\000\000\000\052\000\
\000\000\000\000\000\000\105\000\000\000\000\000\000\000\104\000\
\000\000\000\000\143\000\105\000\105\000\105\000\000\000\000\000\
\000\000\105\000\105\000\105\000\105\000\103\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\103\000\103\000\103\000\
\011\000\105\000\000\000\103\000\103\000\103\000\103\000\142\000\
\011\000\000\000\011\000\000\000\000\000\000\000\011\000\011\000\
\011\000\011\000\052\000\103\000\000\000\000\000\000\000\000\000\
\000\000\000\000\052\000\000\000\052\000\143\000\011\000\000\000\
\052\000\052\000\052\000\052\000\185\000\143\000\000\000\143\000\
\111\000\000\000\000\000\143\000\143\000\143\000\143\000\000\000\
\052\000\112\000\113\000\114\000\115\000\116\000\117\000\118\000\
\119\000\000\000\142\000\143\000\000\000\000\000\120\000\121\000\
\122\000\123\000\142\000\000\000\142\000\000\000\000\000\000\000\
\142\000\142\000\142\000\142\000\000\000\123\000\123\000\218\000\
\123\000\123\000\000\000\123\000\123\000\123\000\000\000\000\000\
\142\000\123\000\111\000\000\000\000\000\000\000\123\000\123\000\
\123\000\123\000\000\000\112\000\113\000\114\000\115\000\116\000\
\117\000\118\000\119\000\000\000\000\000\000\000\000\000\000\000\
\120\000\121\000\122\000\123\000\000\000\000\000\000\000\123\000\
\123\000\000\000\123\000\123\000\123\000\123\000\123\000\123\000\
\000\000\000\000\123\000\123\000\123\000\123\000\123\000\123\000\
\000\000\000\000\000\000\000\000\000\000\000\000\123\000\123\000\
\123\000\123\000\000\000\000\000\000\000\000\000\000\000\000\000\
\123\000\123\000\123\000\123\000\123\000\186\000\065\000\000\000\
\066\000\067\000\000\000\068\000\142\000\000\000\000\000\064\000\
\065\000\187\000\066\000\067\000\000\000\068\000\069\000\070\000\
\071\000\072\000\000\000\000\000\000\000\000\000\000\000\000\000\
\069\000\070\000\071\000\072\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\073\000\
\188\000\000\000\189\000\190\000\191\000\000\000\192\000\000\000\
\000\000\073\000\193\000\194\000\000\000\195\000\196\000\197\000\
\000\000\000\000\000\000\000\000\000\000\000\000\007\000\008\000\
\009\000\010\000\000\000\000\000\000\000\000\000\000\000\000\000\
\074\000\075\000\076\000\077\000\078\000\000\000\000\000\000\000\
\000\000\000\000\074\000\075\000\076\000\077\000\078\000\064\000\
\065\000\000\000\066\000\067\000\000\000\068\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\069\000\070\000\071\000\072\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\034\000\000\000\000\000\000\000\054\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\054\000\
\000\000\073\000\054\000\054\000\054\000\054\000\054\000\054\000\
\054\000\054\000\054\000\054\000\054\000\054\000\054\000\054\000\
\054\000\054\000\054\000\054\000\054\000\054\000\054\000\054\000\
\054\000\054\000\054\000\054\000\054\000\219\000\000\000\000\000\
\000\000\000\000\000\000\075\000\076\000\077\000\078\000\000\000\
\111\000\000\000\000\000\000\000\000\000\000\000\010\001\000\000\
\000\000\112\000\113\000\114\000\115\000\116\000\117\000\118\000\
\119\000\111\000\000\000\000\000\000\000\000\000\120\000\121\000\
\122\000\123\000\112\000\113\000\114\000\115\000\116\000\117\000\
\118\000\119\000\013\001\000\000\000\000\000\000\000\000\120\000\
\121\000\122\000\123\000\000\000\000\000\111\000\000\000\000\000\
\000\000\000\000\000\000\016\001\000\000\000\000\112\000\113\000\
\114\000\115\000\116\000\117\000\118\000\119\000\111\000\000\000\
\000\000\000\000\000\000\120\000\121\000\122\000\123\000\112\000\
\113\000\114\000\115\000\116\000\117\000\118\000\119\000\017\001\
\000\000\000\000\000\000\000\000\120\000\121\000\122\000\123\000\
\000\000\000\000\111\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\112\000\113\000\114\000\115\000\116\000\
\117\000\118\000\119\000\237\000\000\000\000\000\000\000\111\000\
\120\000\121\000\122\000\123\000\000\000\000\000\000\000\000\000\
\112\000\113\000\114\000\115\000\116\000\117\000\118\000\119\000\
\250\000\000\000\000\000\000\000\111\000\120\000\121\000\122\000\
\123\000\000\000\000\000\000\000\000\000\112\000\113\000\114\000\
\115\000\116\000\117\000\118\000\119\000\002\001\000\000\000\000\
\000\000\111\000\120\000\121\000\122\000\123\000\000\000\000\000\
\000\000\000\000\112\000\113\000\114\000\115\000\116\000\117\000\
\118\000\119\000\014\001\000\000\000\000\000\000\111\000\120\000\
\121\000\122\000\123\000\000\000\000\000\000\000\000\000\112\000\
\113\000\114\000\115\000\116\000\117\000\118\000\119\000\020\001\
\000\000\000\000\000\000\111\000\120\000\121\000\122\000\123\000\
\000\000\000\000\000\000\000\000\112\000\113\000\114\000\115\000\
\116\000\117\000\118\000\119\000\025\001\000\000\000\000\000\000\
\111\000\120\000\121\000\122\000\123\000\000\000\000\000\000\000\
\000\000\112\000\113\000\114\000\115\000\116\000\117\000\118\000\
\119\000\030\001\000\000\000\000\000\000\111\000\120\000\121\000\
\122\000\123\000\000\000\000\000\000\000\000\000\112\000\113\000\
\114\000\115\000\116\000\117\000\118\000\119\000\043\001\000\000\
\000\000\000\000\111\000\120\000\121\000\122\000\123\000\000\000\
\000\000\000\000\000\000\112\000\113\000\114\000\115\000\116\000\
\117\000\118\000\119\000\051\001\000\000\000\000\000\000\111\000\
\120\000\121\000\122\000\123\000\000\000\000\000\000\000\000\000\
\112\000\113\000\114\000\115\000\116\000\117\000\118\000\119\000\
\052\001\000\000\000\000\000\000\111\000\120\000\121\000\122\000\
\123\000\000\000\000\000\000\000\000\000\112\000\113\000\114\000\
\115\000\116\000\117\000\118\000\119\000\221\000\000\000\000\000\
\111\000\000\000\120\000\121\000\122\000\123\000\000\000\000\000\
\000\000\112\000\113\000\114\000\115\000\116\000\117\000\118\000\
\119\000\220\000\000\000\111\000\000\000\000\000\120\000\121\000\
\122\000\123\000\000\000\000\000\112\000\113\000\114\000\115\000\
\116\000\117\000\118\000\119\000\000\000\000\000\000\000\000\000\
\000\000\120\000\121\000\122\000\123\000"

let yycheck = "\221\000\
\000\000\203\000\002\001\070\001\223\000\009\001\073\001\043\000\
\002\001\001\000\001\001\002\001\012\001\001\000\006\000\001\001\
\002\001\013\001\004\001\005\001\009\001\007\001\014\000\015\000\
\018\001\194\000\062\000\018\001\002\001\025\001\002\001\067\000\
\018\001\019\001\020\001\021\001\255\000\011\001\065\001\011\001\
\033\000\006\001\008\001\010\001\036\000\001\001\038\000\051\001\
\013\001\042\000\086\000\069\000\070\000\071\000\072\000\073\000\
\005\001\043\001\007\001\001\001\049\001\010\001\051\001\060\001\
\100\000\062\001\001\001\022\001\023\001\024\001\000\000\006\001\
\108\000\109\000\110\000\111\000\112\000\113\000\114\000\115\000\
\116\000\117\000\074\000\252\000\120\000\121\000\122\000\123\000\
\124\000\001\001\076\001\077\001\078\001\079\001\080\001\081\001\
\016\001\010\001\134\000\019\001\053\001\021\001\001\001\095\000\
\060\001\015\001\098\000\053\001\054\001\001\001\066\001\067\001\
\068\001\069\001\027\001\011\001\012\001\135\000\136\000\137\000\
\138\000\139\000\035\001\001\001\001\001\002\001\001\001\004\001\
\005\001\006\001\007\001\066\001\067\001\068\001\069\001\025\001\
\070\001\071\001\001\001\073\001\000\000\018\001\019\001\020\001\
\021\001\026\001\027\001\028\001\029\001\030\001\031\001\032\001\
\033\001\189\000\190\000\014\000\015\000\149\000\150\000\149\000\
\150\000\197\000\061\001\005\001\001\001\007\001\043\001\066\001\
\067\001\068\001\069\001\072\001\025\001\074\001\066\001\067\001\
\068\001\069\001\060\001\018\001\216\000\020\001\138\000\139\000\
\220\000\221\000\011\001\016\001\002\001\225\000\019\001\063\001\
\021\001\229\000\012\001\231\000\025\001\233\000\234\000\076\001\
\077\001\078\001\079\001\080\001\008\001\034\001\035\001\036\001\
\037\001\038\001\000\000\247\000\001\001\006\001\014\001\251\000\
\025\001\005\001\005\001\005\001\005\001\011\001\017\001\001\001\
\004\001\008\001\001\001\001\001\008\001\001\001\001\001\026\001\
\027\001\028\001\029\001\030\001\031\001\032\001\033\001\016\001\
\001\001\009\001\015\001\023\001\039\001\040\001\041\001\042\001\
\001\001\014\001\013\001\031\001\006\001\075\001\005\001\013\001\
\036\001\001\001\005\001\001\001\009\001\013\001\006\001\001\001\
\005\001\005\001\061\001\006\001\071\001\013\001\014\001\015\001\
\016\001\017\001\018\001\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\026\001\027\001\028\001\029\001\030\001\031\001\
\032\001\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\000\000\026\001\027\001\028\001\029\001\
\030\001\031\001\032\001\033\001\052\001\005\001\056\001\001\001\
\013\001\039\001\040\001\070\001\060\001\061\001\062\001\008\001\
\001\001\013\001\066\001\067\001\068\001\069\001\013\001\001\001\
\025\001\013\001\073\001\013\001\006\001\045\001\064\001\049\001\
\002\001\009\001\082\001\013\001\014\001\015\001\051\001\017\001\
\018\001\015\001\020\001\015\001\022\001\023\001\024\001\025\001\
\026\001\027\001\028\001\029\001\030\001\031\001\032\001\033\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\000\000\026\001\027\001\028\001\029\001\030\001\031\001\
\032\001\033\001\052\001\001\001\008\001\008\001\006\001\039\001\
\009\001\073\001\060\001\061\001\062\001\009\001\013\001\009\001\
\066\001\067\001\068\001\069\001\032\000\001\001\032\000\094\000\
\098\000\088\000\006\001\087\000\215\000\038\001\255\255\255\255\
\082\001\013\001\014\001\015\001\255\255\017\001\018\001\255\255\
\020\001\255\255\022\001\023\001\024\001\025\001\026\001\027\001\
\028\001\029\001\030\001\031\001\032\001\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\000\000\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\052\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\060\001\061\001\062\001\255\255\255\255\255\255\066\001\067\001\
\068\001\069\001\255\255\001\001\255\255\255\255\255\255\255\255\
\006\001\255\255\255\255\255\255\255\255\255\255\082\001\013\001\
\014\001\015\001\255\255\017\001\018\001\255\255\020\001\255\255\
\022\001\023\001\024\001\025\001\026\001\027\001\028\001\029\001\
\030\001\031\001\032\001\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\000\000\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\052\001\006\001\
\255\255\255\255\255\255\255\255\255\255\255\255\060\001\061\001\
\062\001\255\255\017\001\255\255\066\001\067\001\068\001\069\001\
\255\255\255\255\255\255\026\001\027\001\028\001\029\001\030\001\
\031\001\032\001\033\001\255\255\082\001\255\255\255\255\255\255\
\039\001\040\001\041\001\042\001\001\001\255\255\255\255\255\255\
\255\255\006\001\255\255\255\255\255\255\255\255\000\000\255\255\
\013\001\014\001\015\001\255\255\017\001\018\001\255\255\020\001\
\255\255\022\001\023\001\024\001\025\001\026\001\027\001\028\001\
\029\001\030\001\031\001\032\001\033\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\052\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\060\001\
\061\001\062\001\255\255\255\255\255\255\066\001\067\001\068\001\
\069\001\255\255\001\001\255\255\255\255\255\255\255\255\006\001\
\255\255\255\255\255\255\255\255\000\000\082\001\013\001\014\001\
\015\001\255\255\017\001\018\001\255\255\020\001\255\255\022\001\
\023\001\024\001\025\001\026\001\027\001\028\001\029\001\030\001\
\031\001\032\001\033\001\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\052\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\060\001\061\001\062\001\
\255\255\255\255\255\255\066\001\067\001\068\001\069\001\255\255\
\001\001\255\255\255\255\255\255\255\255\006\001\255\255\255\255\
\255\255\255\255\000\000\082\001\013\001\014\001\015\001\255\255\
\017\001\018\001\255\255\020\001\255\255\022\001\023\001\024\001\
\255\255\026\001\027\001\028\001\029\001\030\001\031\001\032\001\
\033\001\017\001\255\255\255\255\255\255\255\255\039\001\040\001\
\041\001\042\001\026\001\027\001\028\001\029\001\030\001\031\001\
\032\001\033\001\255\255\052\001\255\255\255\255\255\255\039\001\
\040\001\041\001\042\001\060\001\061\001\062\001\255\255\255\255\
\255\255\066\001\067\001\068\001\069\001\255\255\001\001\255\255\
\255\255\255\255\255\255\006\001\255\255\255\255\255\255\255\255\
\000\000\082\001\013\001\014\001\015\001\255\255\017\001\018\001\
\255\255\020\001\255\255\022\001\023\001\024\001\255\255\026\001\
\027\001\028\001\029\001\030\001\031\001\032\001\033\001\000\000\
\255\255\255\255\255\255\255\255\039\001\040\001\041\001\042\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\052\001\255\255\255\255\255\255\255\255\255\255\001\001\
\255\255\060\001\061\001\062\001\006\001\255\255\255\255\066\001\
\067\001\068\001\069\001\013\001\014\001\015\001\255\255\017\001\
\018\001\255\255\020\001\255\255\022\001\023\001\024\001\082\001\
\026\001\027\001\028\001\029\001\030\001\031\001\032\001\033\001\
\000\000\017\001\255\255\255\255\255\255\039\001\040\001\041\001\
\042\001\255\255\026\001\027\001\028\001\029\001\030\001\031\001\
\032\001\033\001\052\001\255\255\255\255\255\255\255\255\039\001\
\040\001\041\001\060\001\061\001\062\001\255\255\255\255\255\255\
\066\001\067\001\068\001\069\001\255\255\001\001\255\255\255\255\
\255\255\255\255\006\001\255\255\255\255\255\255\255\255\255\255\
\082\001\013\001\014\001\015\001\255\255\017\001\018\001\255\255\
\020\001\000\000\022\001\023\001\024\001\255\255\026\001\027\001\
\028\001\029\001\030\001\031\001\032\001\033\001\255\255\255\255\
\255\255\255\255\255\255\039\001\040\001\041\001\042\001\255\255\
\000\000\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\052\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\060\001\061\001\062\001\255\255\255\255\255\255\066\001\067\001\
\068\001\069\001\255\255\001\001\255\255\255\255\255\255\255\255\
\006\001\255\255\000\000\255\255\255\255\255\255\082\001\013\001\
\014\001\015\001\255\255\017\001\018\001\255\255\020\001\255\255\
\255\255\255\255\255\255\255\255\026\001\027\001\028\001\029\001\
\030\001\031\001\032\001\033\001\000\000\255\255\255\255\255\255\
\255\255\039\001\040\001\041\001\042\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\052\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\060\001\061\001\
\062\001\255\255\255\255\000\000\066\001\067\001\068\001\069\001\
\255\255\001\001\255\255\255\255\255\255\255\255\006\001\255\255\
\255\255\255\255\255\255\255\255\082\001\013\001\014\001\015\001\
\255\255\017\001\018\001\255\255\020\001\255\255\255\255\006\001\
\001\001\255\255\026\001\027\001\028\001\029\001\030\001\031\001\
\032\001\033\001\017\001\255\255\255\255\000\000\255\255\039\001\
\040\001\041\001\042\001\026\001\027\001\028\001\029\001\030\001\
\031\001\032\001\033\001\255\255\052\001\255\255\255\255\255\255\
\039\001\040\001\041\001\042\001\060\001\061\001\062\001\255\255\
\255\255\255\255\066\001\067\001\068\001\069\001\000\000\255\255\
\255\255\255\255\255\255\052\001\255\255\255\255\255\255\255\255\
\255\255\001\001\082\001\060\001\255\255\062\001\006\001\255\255\
\255\255\066\001\067\001\068\001\069\001\013\001\014\001\015\001\
\255\255\017\001\018\001\255\255\020\001\000\000\255\255\255\255\
\255\255\082\001\026\001\027\001\028\001\029\001\030\001\031\001\
\032\001\033\001\255\255\255\255\255\255\255\255\255\255\039\001\
\040\001\041\001\042\001\255\255\255\255\255\255\255\255\000\000\
\255\255\255\255\255\255\255\255\052\001\255\255\255\255\255\255\
\255\255\255\255\001\001\255\255\060\001\061\001\062\001\006\001\
\255\255\000\000\066\001\067\001\068\001\069\001\013\001\014\001\
\015\001\255\255\017\001\255\255\000\000\255\255\255\255\255\255\
\255\255\001\001\082\001\026\001\027\001\028\001\029\001\030\001\
\031\001\032\001\033\001\255\255\255\255\255\255\000\000\255\255\
\039\001\040\001\041\001\042\001\255\255\255\255\255\255\255\255\
\255\255\000\000\255\255\255\255\255\255\052\001\255\255\255\255\
\255\255\255\255\255\255\001\001\255\255\060\001\061\001\062\001\
\006\001\255\255\255\255\066\001\067\001\068\001\069\001\013\001\
\014\001\015\001\255\255\017\001\052\001\255\255\000\000\255\255\
\255\255\255\255\255\255\082\001\060\001\001\001\062\001\255\255\
\255\255\255\255\066\001\067\001\068\001\069\001\255\255\255\255\
\255\255\039\001\040\001\041\001\042\001\255\255\255\255\255\255\
\255\255\255\255\082\001\255\255\255\255\255\255\052\001\255\255\
\255\255\255\255\255\255\255\255\001\001\255\255\060\001\061\001\
\062\001\006\001\255\255\255\255\066\001\067\001\068\001\069\001\
\013\001\014\001\015\001\255\255\017\001\255\255\255\255\255\255\
\052\001\255\255\255\255\255\255\082\001\255\255\255\255\255\255\
\060\001\255\255\062\001\255\255\255\255\255\255\066\001\067\001\
\068\001\069\001\255\255\040\001\041\001\042\001\001\001\255\255\
\255\255\255\255\255\255\006\001\255\255\255\255\082\001\052\001\
\255\255\255\255\013\001\014\001\015\001\255\255\017\001\060\001\
\061\001\062\001\255\255\255\255\255\255\066\001\067\001\068\001\
\069\001\255\255\255\255\255\255\255\255\255\255\255\255\001\001\
\255\255\255\255\255\255\255\255\006\001\082\001\041\001\042\001\
\255\255\255\255\255\255\013\001\014\001\015\001\255\255\017\001\
\255\255\052\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\060\001\061\001\062\001\255\255\255\255\001\001\066\001\
\067\001\068\001\069\001\006\001\255\255\255\255\255\255\041\001\
\042\001\255\255\013\001\014\001\015\001\255\255\255\255\082\001\
\255\255\255\255\052\001\255\255\255\255\255\255\255\255\255\255\
\001\001\255\255\060\001\061\001\062\001\006\001\255\255\255\255\
\066\001\067\001\068\001\069\001\013\001\014\001\015\001\042\001\
\255\255\255\255\001\001\255\255\255\255\255\255\255\255\006\001\
\082\001\052\001\255\255\255\255\255\255\001\001\013\001\014\001\
\015\001\060\001\061\001\062\001\255\255\255\255\255\255\066\001\
\067\001\068\001\069\001\255\255\255\255\255\255\255\255\001\001\
\255\255\255\255\255\255\052\001\255\255\255\255\255\255\082\001\
\255\255\255\255\001\001\060\001\061\001\062\001\255\255\255\255\
\255\255\066\001\067\001\068\001\069\001\052\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\060\001\061\001\062\001\
\052\001\082\001\255\255\066\001\067\001\068\001\069\001\001\001\
\060\001\255\255\062\001\255\255\255\255\255\255\066\001\067\001\
\068\001\069\001\052\001\082\001\255\255\255\255\255\255\255\255\
\255\255\255\255\060\001\255\255\062\001\052\001\082\001\255\255\
\066\001\067\001\068\001\069\001\013\001\060\001\255\255\062\001\
\017\001\255\255\255\255\066\001\067\001\068\001\069\001\255\255\
\082\001\026\001\027\001\028\001\029\001\030\001\031\001\032\001\
\033\001\255\255\052\001\082\001\255\255\255\255\039\001\040\001\
\041\001\042\001\060\001\255\255\062\001\255\255\255\255\255\255\
\066\001\067\001\068\001\069\001\255\255\001\001\002\001\006\001\
\004\001\005\001\255\255\007\001\008\001\009\001\255\255\255\255\
\082\001\013\001\017\001\255\255\255\255\255\255\018\001\019\001\
\020\001\021\001\255\255\026\001\027\001\028\001\029\001\030\001\
\031\001\032\001\033\001\255\255\255\255\255\255\255\255\255\255\
\039\001\040\001\041\001\042\001\255\255\255\255\255\255\043\001\
\044\001\255\255\046\001\047\001\048\001\049\001\050\001\051\001\
\255\255\255\255\054\001\055\001\056\001\057\001\058\001\059\001\
\255\255\255\255\255\255\255\255\255\255\255\255\066\001\067\001\
\068\001\069\001\255\255\255\255\255\255\255\255\255\255\255\255\
\076\001\077\001\078\001\079\001\080\001\001\001\002\001\255\255\
\004\001\005\001\255\255\007\001\008\001\255\255\255\255\001\001\
\002\001\013\001\004\001\005\001\255\255\007\001\018\001\019\001\
\020\001\021\001\255\255\255\255\255\255\255\255\255\255\255\255\
\018\001\019\001\020\001\021\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\043\001\
\044\001\255\255\046\001\047\001\048\001\255\255\050\001\255\255\
\255\255\043\001\054\001\055\001\255\255\057\001\058\001\059\001\
\255\255\255\255\255\255\255\255\255\255\255\255\066\001\067\001\
\068\001\069\001\255\255\255\255\255\255\255\255\255\255\255\255\
\076\001\077\001\078\001\079\001\080\001\255\255\255\255\255\255\
\255\255\255\255\076\001\077\001\078\001\079\001\080\001\001\001\
\002\001\255\255\004\001\005\001\255\255\007\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\018\001\019\001\020\001\021\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\001\001\255\255\255\255\255\255\005\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\013\001\
\255\255\043\001\016\001\017\001\018\001\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\026\001\027\001\028\001\029\001\
\030\001\031\001\032\001\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\006\001\255\255\255\255\
\255\255\255\255\255\255\077\001\078\001\079\001\080\001\255\255\
\017\001\255\255\255\255\255\255\255\255\255\255\006\001\255\255\
\255\255\026\001\027\001\028\001\029\001\030\001\031\001\032\001\
\033\001\017\001\255\255\255\255\255\255\255\255\039\001\040\001\
\041\001\042\001\026\001\027\001\028\001\029\001\030\001\031\001\
\032\001\033\001\006\001\255\255\255\255\255\255\255\255\039\001\
\040\001\041\001\042\001\255\255\255\255\017\001\255\255\255\255\
\255\255\255\255\255\255\006\001\255\255\255\255\026\001\027\001\
\028\001\029\001\030\001\031\001\032\001\033\001\017\001\255\255\
\255\255\255\255\255\255\039\001\040\001\041\001\042\001\026\001\
\027\001\028\001\029\001\030\001\031\001\032\001\033\001\006\001\
\255\255\255\255\255\255\255\255\039\001\040\001\041\001\042\001\
\255\255\255\255\017\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\026\001\027\001\028\001\029\001\030\001\
\031\001\032\001\033\001\013\001\255\255\255\255\255\255\017\001\
\039\001\040\001\041\001\042\001\255\255\255\255\255\255\255\255\
\026\001\027\001\028\001\029\001\030\001\031\001\032\001\033\001\
\013\001\255\255\255\255\255\255\017\001\039\001\040\001\041\001\
\042\001\255\255\255\255\255\255\255\255\026\001\027\001\028\001\
\029\001\030\001\031\001\032\001\033\001\013\001\255\255\255\255\
\255\255\017\001\039\001\040\001\041\001\042\001\255\255\255\255\
\255\255\255\255\026\001\027\001\028\001\029\001\030\001\031\001\
\032\001\033\001\013\001\255\255\255\255\255\255\017\001\039\001\
\040\001\041\001\042\001\255\255\255\255\255\255\255\255\026\001\
\027\001\028\001\029\001\030\001\031\001\032\001\033\001\013\001\
\255\255\255\255\255\255\017\001\039\001\040\001\041\001\042\001\
\255\255\255\255\255\255\255\255\026\001\027\001\028\001\029\001\
\030\001\031\001\032\001\033\001\013\001\255\255\255\255\255\255\
\017\001\039\001\040\001\041\001\042\001\255\255\255\255\255\255\
\255\255\026\001\027\001\028\001\029\001\030\001\031\001\032\001\
\033\001\013\001\255\255\255\255\255\255\017\001\039\001\040\001\
\041\001\042\001\255\255\255\255\255\255\255\255\026\001\027\001\
\028\001\029\001\030\001\031\001\032\001\033\001\013\001\255\255\
\255\255\255\255\017\001\039\001\040\001\041\001\042\001\255\255\
\255\255\255\255\255\255\026\001\027\001\028\001\029\001\030\001\
\031\001\032\001\033\001\013\001\255\255\255\255\255\255\017\001\
\039\001\040\001\041\001\042\001\255\255\255\255\255\255\255\255\
\026\001\027\001\028\001\029\001\030\001\031\001\032\001\033\001\
\013\001\255\255\255\255\255\255\017\001\039\001\040\001\041\001\
\042\001\255\255\255\255\255\255\255\255\026\001\027\001\028\001\
\029\001\030\001\031\001\032\001\033\001\014\001\255\255\255\255\
\017\001\255\255\039\001\040\001\041\001\042\001\255\255\255\255\
\255\255\026\001\027\001\028\001\029\001\030\001\031\001\032\001\
\033\001\015\001\255\255\017\001\255\255\255\255\039\001\040\001\
\041\001\042\001\255\255\255\255\026\001\027\001\028\001\029\001\
\030\001\031\001\032\001\033\001\255\255\255\255\255\255\255\255\
\255\255\039\001\040\001\041\001\042\001"

let yynames_const = "\
  NULL\000\
  LPAR\000\
  RPAR\000\
  LPARRPAR\000\
  LBRACE\000\
  RBRACE\000\
  LSQUARE\000\
  RSQUARE\000\
  DOTDOT\000\
  SEMICOLON\000\
  COMMA\000\
  COLON\000\
  DOT\000\
  QUESTION\000\
  MINUS\000\
  MINUSMINUS\000\
  PLUS\000\
  PLUSPLUS\000\
  STAR\000\
  SLASH\000\
  PERCENT\000\
  EQ\000\
  LTEQ\000\
  GTEQ\000\
  GT\000\
  LT\000\
  EQEQ\000\
  BANGEQ\000\
  LTCOLON\000\
  COLONGT\000\
  PLUSEQ\000\
  MINUSEQ\000\
  STAREQ\000\
  SLASHEQ\000\
  PERCENTEQ\000\
  AMPAMP\000\
  BARBAR\000\
  EQGT\000\
  LTEQGT\000\
  EXCLAM\000\
  IF\000\
  ELSE\000\
  RETURN\000\
  WHILE\000\
  BREAK\000\
  CASE\000\
  SWITCH\000\
  DEFAULT\000\
  EXCEPTION\000\
  OF\000\
  THROW\000\
  TRY\000\
  CATCH\000\
  PACK\000\
  UNPACK\000\
  ASSERT\000\
  TYPE\000\
  INVARIANT\000\
  LOGIC\000\
  WITH\000\
  VARIANT\000\
  AND\000\
  INTEGER\000\
  BOOLEAN\000\
  REAL\000\
  UNIT\000\
  ASSIGNS\000\
  ASSUMES\000\
  BEHAVIOR\000\
  ENSURES\000\
  REQUIRES\000\
  THROWS\000\
  BSFORALL\000\
  BSOFFSET_MAX\000\
  BSOFFSET_MIN\000\
  BSOLD\000\
  BSRESULT\000\
  BSNOTHING\000\
  AXIOM\000\
  EOF\000\
  "

let yynames_block = "\
  IDENTIFIER\000\
  CONSTANT\000\
  STRING_LITERAL\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Jc_ast.pdecl list) in
    Obj.repr(
# 170 "jc/jc_parser.mly"
    ( _1::_2 )
# 1041 "jc/jc_parser.ml"
               : Jc_ast.pdecl list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'rec_decls) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Jc_ast.pdecl list) in
    Obj.repr(
# 172 "jc/jc_parser.mly"
    ( _1::_2 )
# 1049 "jc/jc_parser.ml"
               : Jc_ast.pdecl list))
; (fun __caml_parser_env ->
    Obj.repr(
# 174 "jc/jc_parser.mly"
    ( [] )
# 1055 "jc/jc_parser.ml"
               : Jc_ast.pdecl list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_rec_definitions) in
    Obj.repr(
# 179 "jc/jc_parser.mly"
    ( locate_decl (JCPDrectypes(_1)) )
# 1062 "jc/jc_parser.ml"
               : 'rec_decls))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 183 "jc/jc_parser.mly"
    ( _1 )
# 1069 "jc/jc_parser.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_definition) in
    Obj.repr(
# 185 "jc/jc_parser.mly"
    ( _1 )
# 1076 "jc/jc_parser.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'axiom_definition) in
    Obj.repr(
# 187 "jc/jc_parser.mly"
    ( _1 )
# 1083 "jc/jc_parser.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'exception_definition) in
    Obj.repr(
# 189 "jc/jc_parser.mly"
    ( _1 )
# 1090 "jc/jc_parser.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'logic_definition) in
    Obj.repr(
# 191 "jc/jc_parser.mly"
    ( _1 )
# 1097 "jc/jc_parser.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'type_definition) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'type_rec_definitions) in
    Obj.repr(
# 205 "jc/jc_parser.mly"
    ( _1::_3 )
# 1105 "jc/jc_parser.ml"
               : 'type_rec_definitions))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'type_definition) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'type_definition) in
    Obj.repr(
# 207 "jc/jc_parser.mly"
    ( _1::[_3] )
# 1113 "jc/jc_parser.ml"
               : 'type_rec_definitions))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'int_constant) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'int_constant) in
    Obj.repr(
# 211 "jc/jc_parser.mly"
    ( locate_decl (JCPDrangetype(_2,_4,_6)) )
# 1122 "jc/jc_parser.ml"
               : 'type_definition))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 5 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'extends) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'field_declaration_list) in
    Obj.repr(
# 213 "jc/jc_parser.mly"
    ( let (f,i) = _6 in locate_decl (JCPDstructtype(_2,_4,f,i)) )
# 1131 "jc/jc_parser.ml"
               : 'type_definition))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 215 "jc/jc_parser.mly"
    ( locate_decl (JCPDlogictype(_3)) )
# 1138 "jc/jc_parser.ml"
               : 'type_definition))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Jc_ast.const) in
    Obj.repr(
# 220 "jc/jc_parser.mly"
    ( num_of_constant (loc_i 1)_1 )
# 1145 "jc/jc_parser.ml"
               : 'int_constant))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Jc_ast.const) in
    Obj.repr(
# 222 "jc/jc_parser.mly"
    ( Num.minus_num (num_of_constant (loc_i 2) _2) )
# 1152 "jc/jc_parser.ml"
               : 'int_constant))
; (fun __caml_parser_env ->
    Obj.repr(
# 227 "jc/jc_parser.mly"
    ( None )
# 1158 "jc/jc_parser.ml"
               : 'extends))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : string) in
    Obj.repr(
# 229 "jc/jc_parser.mly"
    ( Some _1 )
# 1165 "jc/jc_parser.ml"
               : 'extends))
; (fun __caml_parser_env ->
    Obj.repr(
# 234 "jc/jc_parser.mly"
    ( ([],[]) )
# 1171 "jc/jc_parser.ml"
               : 'field_declaration_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'field_declaration) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'field_declaration_list) in
    Obj.repr(
# 236 "jc/jc_parser.mly"
    ( let (f,i) = _2 in (_1::f,i) )
# 1179 "jc/jc_parser.ml"
               : 'field_declaration_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'invariant) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'field_declaration_list) in
    Obj.repr(
# 238 "jc/jc_parser.mly"
    ( let (f,i) = _2 in (f,_1::i) )
# 1187 "jc/jc_parser.ml"
               : 'field_declaration_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'type_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string) in
    Obj.repr(
# 243 "jc/jc_parser.mly"
    ( (_1,_2) )
# 1195 "jc/jc_parser.ml"
               : 'field_declaration))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 6 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 4 : string) in
    let _7 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 248 "jc/jc_parser.mly"
    ( (_2,_4,_7) )
# 1204 "jc/jc_parser.ml"
               : 'invariant))
; (fun __caml_parser_env ->
    Obj.repr(
# 260 "jc/jc_parser.mly"
    ( [] )
# 1210 "jc/jc_parser.ml"
               : 'parameters))
; (fun __caml_parser_env ->
    Obj.repr(
# 262 "jc/jc_parser.mly"
    ( [] )
# 1216 "jc/jc_parser.ml"
               : 'parameters))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_comma_list) in
    Obj.repr(
# 264 "jc/jc_parser.mly"
    ( _2 )
# 1223 "jc/jc_parser.ml"
               : 'parameters))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_declaration) in
    Obj.repr(
# 269 "jc/jc_parser.mly"
    ( [_1] )
# 1230 "jc/jc_parser.ml"
               : 'parameter_comma_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter_declaration) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_comma_list) in
    Obj.repr(
# 271 "jc/jc_parser.mly"
    ( _1 :: _3 )
# 1238 "jc/jc_parser.ml"
               : 'parameter_comma_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 276 "jc/jc_parser.mly"
    ( (_1,_2) )
# 1246 "jc/jc_parser.ml"
               : 'parameter_declaration))
; (fun __caml_parser_env ->
    Obj.repr(
# 282 "jc/jc_parser.mly"
    ( locate_type (JCPTnative Tinteger) )
# 1252 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 284 "jc/jc_parser.mly"
    ( locate_type (JCPTnative Tboolean) )
# 1258 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 286 "jc/jc_parser.mly"
    ( locate_type (JCPTnative Treal) )
# 1264 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 288 "jc/jc_parser.mly"
    ( locate_type (JCPTnative Tunit) )
# 1270 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 290 "jc/jc_parser.mly"
    ( locate_type (JCPTidentifier _1) )
# 1277 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    Obj.repr(
# 292 "jc/jc_parser.mly"
    ( locate_type (JCPTpointer(_1,zero,minus_one)) )
# 1284 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Jc_ast.const) in
    Obj.repr(
# 294 "jc/jc_parser.mly"
    ( let n = num_of_constant (loc_i 3) _3 in
      locate_type (JCPTpointer(_1,n,n)) )
# 1293 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Jc_ast.const) in
    Obj.repr(
# 297 "jc/jc_parser.mly"
    ( let n = num_of_constant (loc_i 3) _3 in
      locate_type (JCPTpointer(_1,n,Num.pred_num n)) )
# 1302 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Jc_ast.const) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Jc_ast.const) in
    Obj.repr(
# 300 "jc/jc_parser.mly"
    ( let n = num_of_constant (loc_i 3) _3 in
      let m = num_of_constant (loc_i 5) _5 in
      locate_type (JCPTpointer(_1,n,m)) )
# 1313 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Jc_ast.const) in
    Obj.repr(
# 304 "jc/jc_parser.mly"
    ( let m = num_of_constant (loc_i 4) _4 in
      locate_type (JCPTpointer(_1,Num.succ_num m,m)) )
# 1322 "jc/jc_parser.ml"
               : 'type_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 310 "jc/jc_parser.mly"
    ( [] )
# 1328 "jc/jc_parser.ml"
               : 'function_specification))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'spec_clause) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'function_specification) in
    Obj.repr(
# 312 "jc/jc_parser.mly"
    ( _1::_2 )
# 1336 "jc/jc_parser.ml"
               : 'function_specification))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 317 "jc/jc_parser.mly"
    ( JCPCrequires(_2) )
# 1343 "jc/jc_parser.ml"
               : 'spec_clause))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 7 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 5 : 'throws) in
    let _5 = (Parsing.peek_val __caml_parser_env 4 : 'assumes) in
    let _6 = (Parsing.peek_val __caml_parser_env 3 : 'assigns) in
    let _8 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 319 "jc/jc_parser.mly"
    ( JCPCbehavior(_2,_4,_5,_6,_8) )
# 1354 "jc/jc_parser.ml"
               : 'spec_clause))
; (fun __caml_parser_env ->
    Obj.repr(
# 325 "jc/jc_parser.mly"
    ( None )
# 1360 "jc/jc_parser.ml"
               : 'throws))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'identifier) in
    Obj.repr(
# 327 "jc/jc_parser.mly"
    ( Some _2 )
# 1367 "jc/jc_parser.ml"
               : 'throws))
; (fun __caml_parser_env ->
    Obj.repr(
# 332 "jc/jc_parser.mly"
    ( None )
# 1373 "jc/jc_parser.ml"
               : 'assumes))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 334 "jc/jc_parser.mly"
    ( Some _2 )
# 1380 "jc/jc_parser.ml"
               : 'assumes))
; (fun __caml_parser_env ->
    Obj.repr(
# 339 "jc/jc_parser.mly"
    ( None )
# 1386 "jc/jc_parser.ml"
               : 'assigns))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'argument_expression_list) in
    Obj.repr(
# 341 "jc/jc_parser.mly"
    ( Some _2 )
# 1393 "jc/jc_parser.ml"
               : 'assigns))
; (fun __caml_parser_env ->
    Obj.repr(
# 343 "jc/jc_parser.mly"
    ( Some [] )
# 1399 "jc/jc_parser.ml"
               : 'assigns))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'type_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'parameters) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'function_specification) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'compound_statement) in
    Obj.repr(
# 349 "jc/jc_parser.mly"
    ( locate_decl (JCPDfun(_1, _2, _3, _4, _5)) )
# 1410 "jc/jc_parser.ml"
               : 'function_definition))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 358 "jc/jc_parser.mly"
    ( locate_decl( JCPDaxiom(_2,_4)) )
# 1418 "jc/jc_parser.ml"
               : 'axiom_definition))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'type_expr) in
    Obj.repr(
# 368 "jc/jc_parser.mly"
    ( locate_decl (JCPDexception(_2,_4)) )
# 1426 "jc/jc_parser.ml"
               : 'exception_definition))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 378 "jc/jc_parser.mly"
    ( locate_expr (JCPEvar _1) )
# 1433 "jc/jc_parser.ml"
               : 'primary_expression))
; (fun __caml_parser_env ->
    Obj.repr(
# 380 "jc/jc_parser.mly"
    ( locate_expr (JCPEvar "\\result") )
# 1439 "jc/jc_parser.ml"
               : 'primary_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Jc_ast.const) in
    Obj.repr(
# 382 "jc/jc_parser.mly"
    ( locate_expr (JCPEconst _1) )
# 1446 "jc/jc_parser.ml"
               : 'primary_expression))
; (fun __caml_parser_env ->
    Obj.repr(
# 384 "jc/jc_parser.mly"
    ( locate_expr (JCPEconst JCCvoid) )
# 1452 "jc/jc_parser.ml"
               : 'primary_expression))
; (fun __caml_parser_env ->
    Obj.repr(
# 386 "jc/jc_parser.mly"
    ( locate_expr (JCPEconst JCCnull) )
# 1458 "jc/jc_parser.ml"
               : 'primary_expression))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 391 "jc/jc_parser.mly"
                       ( _2 )
# 1465 "jc/jc_parser.ml"
               : 'primary_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'primary_expression) in
    Obj.repr(
# 396 "jc/jc_parser.mly"
    ( _1 )
# 1472 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'primary_expression) in
    Obj.repr(
# 398 "jc/jc_parser.mly"
    ( locate_expr (JCPEapp(_1, [])) )
# 1479 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'primary_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_expression_list) in
    Obj.repr(
# 400 "jc/jc_parser.mly"
    ( locate_expr (JCPEapp(_1, _3)) )
# 1487 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 402 "jc/jc_parser.mly"
    ( locate_expr (JCPEold(_3)) )
# 1494 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 404 "jc/jc_parser.mly"
    ( locate_expr (JCPEoffset_max(_3)) )
# 1501 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 406 "jc/jc_parser.mly"
    ( locate_expr (JCPEoffset_min(_3)) )
# 1508 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 408 "jc/jc_parser.mly"
    ( locate_expr (JCPEderef (_1, _3)) )
# 1516 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expression) in
    Obj.repr(
# 410 "jc/jc_parser.mly"
    ( locate_expr (JCPEunary (Upostfix_inc, _1)) )
# 1523 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expression) in
    Obj.repr(
# 412 "jc/jc_parser.mly"
    ( locate_expr (JCPEunary (Upostfix_dec, _1)) )
# 1530 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 414 "jc/jc_parser.mly"
    ( locate_expr (JCPEunary (Uprefix_inc, _2)) )
# 1537 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 416 "jc/jc_parser.mly"
    ( locate_expr (JCPEunary (Uprefix_dec, _2)) )
# 1544 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 418 "jc/jc_parser.mly"
    ( locate_expr (JCPEunary (Uplus, _2)) )
# 1551 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 420 "jc/jc_parser.mly"
    ( locate_expr (JCPEunary (Uminus, _2)) )
# 1558 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 426 "jc/jc_parser.mly"
    ( locate_expr (JCPEunary (Unot, _2)) )
# 1565 "jc/jc_parser.ml"
               : 'postfix_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 431 "jc/jc_parser.mly"
    ( [_1] )
# 1572 "jc/jc_parser.ml"
               : 'argument_expression_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argument_expression_list) in
    Obj.repr(
# 433 "jc/jc_parser.mly"
    ( _1::_3 )
# 1580 "jc/jc_parser.ml"
               : 'argument_expression_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 439 "jc/jc_parser.mly"
    ( _1 )
# 1587 "jc/jc_parser.ml"
               : 'multiplicative_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'multiplicative_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 441 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Bmul, _3)) )
# 1595 "jc/jc_parser.ml"
               : 'multiplicative_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'multiplicative_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 443 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Bdiv, _3)) )
# 1603 "jc/jc_parser.ml"
               : 'multiplicative_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'multiplicative_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expression) in
    Obj.repr(
# 445 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Bmod, _3)) )
# 1611 "jc/jc_parser.ml"
               : 'multiplicative_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'multiplicative_expression) in
    Obj.repr(
# 450 "jc/jc_parser.mly"
    ( _1 )
# 1618 "jc/jc_parser.ml"
               : 'additive_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'additive_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'multiplicative_expression) in
    Obj.repr(
# 452 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Badd, _3)) )
# 1626 "jc/jc_parser.ml"
               : 'additive_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'additive_expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'multiplicative_expression) in
    Obj.repr(
# 454 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Bsub, _3)) )
# 1634 "jc/jc_parser.ml"
               : 'additive_expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'additive_expression) in
    Obj.repr(
# 459 "jc/jc_parser.mly"
    ( _1 )
# 1641 "jc/jc_parser.ml"
               : 'shift_expression))
; (fun __caml_parser_env ->
    Obj.repr(
# 469 "jc/jc_parser.mly"
     ( `Aeq )
# 1647 "jc/jc_parser.ml"
               : 'assignment_operator))
; (fun __caml_parser_env ->
    Obj.repr(
# 470 "jc/jc_parser.mly"
         ( `Aadd )
# 1653 "jc/jc_parser.ml"
               : 'assignment_operator))
; (fun __caml_parser_env ->
    Obj.repr(
# 471 "jc/jc_parser.mly"
          ( `Asub )
# 1659 "jc/jc_parser.ml"
               : 'assignment_operator))
; (fun __caml_parser_env ->
    Obj.repr(
# 472 "jc/jc_parser.mly"
         ( `Amul )
# 1665 "jc/jc_parser.ml"
               : 'assignment_operator))
; (fun __caml_parser_env ->
    Obj.repr(
# 473 "jc/jc_parser.mly"
          ( `Adiv )
# 1671 "jc/jc_parser.ml"
               : 'assignment_operator))
; (fun __caml_parser_env ->
    Obj.repr(
# 474 "jc/jc_parser.mly"
            ( `Amod )
# 1677 "jc/jc_parser.ml"
               : 'assignment_operator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'shift_expression) in
    Obj.repr(
# 487 "jc/jc_parser.mly"
    ( _1 )
# 1684 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 489 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Blt, _3)) )
# 1692 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 491 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Bgt, _3)) )
# 1700 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 493 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Ble, _3)) )
# 1708 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 495 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Bge, _3)) )
# 1716 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 497 "jc/jc_parser.mly"
    ( locate_expr (JCPEinstanceof(_1, _3)) )
# 1724 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 499 "jc/jc_parser.mly"
    ( locate_expr (JCPEcast(_1, _3)) )
# 1732 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 501 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Beq, _3)) )
# 1740 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 503 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary (_1, Bneq, _3)) )
# 1748 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 517 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary(_1, Bland, _3)) )
# 1756 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 519 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary(_1, Blor, _3)) )
# 1764 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 521 "jc/jc_parser.mly"
    ( locate_expr (JCPEif (_1, _3, _5)) )
# 1773 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expression) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'assignment_operator) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 523 "jc/jc_parser.mly"
    ( let a  =
	match _2 with
		| `Aeq -> JCPEassign (_1, _3)
		| `Aadd -> JCPEassign_op (_1, Badd, _3)
		| `Asub -> JCPEassign_op (_1, Bsub, _3)
		| `Amul -> JCPEassign_op (_1, Bmul, _3)
		| `Adiv -> JCPEassign_op (_1, Bdiv, _3)
		| `Amod -> JCPEassign_op (_1, Bmod, _3)
(*
		| Aleft -> CEassign_op ($1, Bshift_left, $3)
		| Aright -> CEassign_op ($1, Bshift_right, $3)
		| Aand -> CEassign_op ($1, Bbw_and, $3)
		| Axor -> CEassign_op ($1, Bbw_xor, $3)
		| Aor -> CEassign_op ($1, Bbw_or, $3)
*)
      in locate_expr a )
# 1797 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'type_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'identifier_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 542 "jc/jc_parser.mly"
    ( locate_expr (JCPEforall(_2,_3,_5)) )
# 1806 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 544 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary(_1,Bimplies,_3)) )
# 1814 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 546 "jc/jc_parser.mly"
    ( locate_expr (JCPEbinary(_1,Biff,_3)) )
# 1822 "jc/jc_parser.ml"
               : 'expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 554 "jc/jc_parser.mly"
    ( [_1] )
# 1829 "jc/jc_parser.ml"
               : 'identifier_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_list) in
    Obj.repr(
# 556 "jc/jc_parser.mly"
    ( _1 :: _3 )
# 1837 "jc/jc_parser.ml"
               : 'identifier_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 561 "jc/jc_parser.mly"
    ( { jc_identifier_loc = loc () ; jc_identifier_name = _1 } )
# 1844 "jc/jc_parser.ml"
               : 'identifier))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'type_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string) in
    Obj.repr(
# 571 "jc/jc_parser.mly"
    ( locate_statement (JCPSdecl(_1,_2,None)) )
# 1852 "jc/jc_parser.ml"
               : 'declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'type_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 573 "jc/jc_parser.mly"
    ( locate_statement (JCPSdecl(_1,_2,Some _4)) )
# 1861 "jc/jc_parser.ml"
               : 'declaration))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Jc_ast.const) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'statement_list) in
    Obj.repr(
# 590 "jc/jc_parser.mly"
    ( Case _2, _4 )
# 1869 "jc/jc_parser.ml"
               : 'case_statement))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'statement_list) in
    Obj.repr(
# 595 "jc/jc_parser.mly"
    ( Default, _3 )
# 1876 "jc/jc_parser.ml"
               : 'default_statement))
; (fun __caml_parser_env ->
    Obj.repr(
# 600 "jc/jc_parser.mly"
    ( [] )
# 1882 "jc/jc_parser.ml"
               : 'case_statement_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'case_statement) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'case_statement_list) in
    Obj.repr(
# 602 "jc/jc_parser.mly"
    ( _1 :: _2 )
# 1890 "jc/jc_parser.ml"
               : 'case_statement_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'case_statement_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'default_statement) in
    Obj.repr(
# 607 "jc/jc_parser.mly"
    ( _1 @ [_2] )
# 1898 "jc/jc_parser.ml"
               : 'default_case_statement_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'case_statement_list) in
    Obj.repr(
# 609 "jc/jc_parser.mly"
    ( _1 )
# 1905 "jc/jc_parser.ml"
               : 'default_case_statement_list))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'statement_list) in
    Obj.repr(
# 614 "jc/jc_parser.mly"
     ( _2 )
# 1912 "jc/jc_parser.ml"
               : 'compound_statement))
; (fun __caml_parser_env ->
    Obj.repr(
# 619 "jc/jc_parser.mly"
    ( [] )
# 1918 "jc/jc_parser.ml"
               : 'statement_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'statement) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'statement_list) in
    Obj.repr(
# 621 "jc/jc_parser.mly"
    ( _1 :: _2 )
# 1926 "jc/jc_parser.ml"
               : 'statement_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 627 "jc/jc_parser.mly"
    ( skip )
# 1932 "jc/jc_parser.ml"
               : 'expression_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 632 "jc/jc_parser.mly"
    ( locate_statement (JCPSexpr _1) )
# 1939 "jc/jc_parser.ml"
               : 'expression_statement))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 634 "jc/jc_parser.mly"
    ( locate_statement (JCPSassert _2) )
# 1946 "jc/jc_parser.ml"
               : 'expression_statement))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'statement) in
    Obj.repr(
# 640 "jc/jc_parser.mly"
    ( locate_statement (JCPSif(_3, _5, skip)) )
# 1954 "jc/jc_parser.ml"
               : 'selection_statement))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : 'statement) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : 'statement) in
    Obj.repr(
# 642 "jc/jc_parser.mly"
    ( locate_statement (JCPSif (_3, _5, _7)) )
# 1963 "jc/jc_parser.ml"
               : 'selection_statement))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'default_case_statement_list) in
    Obj.repr(
# 644 "jc/jc_parser.mly"
    ( locate_statement (JCPSswitch (_3, _6)) )
# 1971 "jc/jc_parser.ml"
               : 'selection_statement))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'loop_annot) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'statement) in
    Obj.repr(
# 649 "jc/jc_parser.mly"
    ( let (i,v) = _3 in 
      locate_statement (JCPSwhile (_2, i, v, _4)) )
# 1981 "jc/jc_parser.ml"
               : 'iteration_statement))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 669 "jc/jc_parser.mly"
    ( (_2,_5) )
# 1989 "jc/jc_parser.ml"
               : 'loop_annot))
; (fun __caml_parser_env ->
    Obj.repr(
# 677 "jc/jc_parser.mly"
                  ( locate_statement (JCPSbreak "") )
# 1995 "jc/jc_parser.ml"
               : 'jump_statement))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 681 "jc/jc_parser.mly"
                              ( locate_statement (JCPSreturn _2) )
# 2002 "jc/jc_parser.ml"
               : 'jump_statement))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    Obj.repr(
# 686 "jc/jc_parser.mly"
    ( locate_statement (JCPSpack _3 ) )
# 2009 "jc/jc_parser.ml"
               : 'pack_statement))
; (fun __caml_parser_env ->
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'expression) in
    Obj.repr(
# 688 "jc/jc_parser.mly"
    ( locate_statement (JCPSunpack _3 ) )
# 2016 "jc/jc_parser.ml"
               : 'pack_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'compound_statement) in
    Obj.repr(
# 697 "jc/jc_parser.mly"
    ( locate_statement (JCPSblock _1) )
# 2023 "jc/jc_parser.ml"
               : 'statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'expression_statement) in
    Obj.repr(
# 699 "jc/jc_parser.mly"
    ( _1 )
# 2030 "jc/jc_parser.ml"
               : 'statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'selection_statement) in
    Obj.repr(
# 701 "jc/jc_parser.mly"
    ( _1 )
# 2037 "jc/jc_parser.ml"
               : 'statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'iteration_statement) in
    Obj.repr(
# 703 "jc/jc_parser.mly"
    ( _1 )
# 2044 "jc/jc_parser.ml"
               : 'statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'jump_statement) in
    Obj.repr(
# 705 "jc/jc_parser.mly"
    ( _1 )
# 2051 "jc/jc_parser.ml"
               : 'statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaration) in
    Obj.repr(
# 707 "jc/jc_parser.mly"
    ( _1 )
# 2058 "jc/jc_parser.ml"
               : 'statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'pack_statement) in
    Obj.repr(
# 711 "jc/jc_parser.mly"
                 ( _1 )
# 2065 "jc/jc_parser.ml"
               : 'statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'exception_statement) in
    Obj.repr(
# 712 "jc/jc_parser.mly"
                      ( _1 )
# 2072 "jc/jc_parser.ml"
               : 'statement))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'expression) in
    Obj.repr(
# 718 "jc/jc_parser.mly"
   ( locate_statement (JCPSthrow(_2,Some _3)) )
# 2080 "jc/jc_parser.ml"
               : 'exception_statement))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'statement) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'identifier) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : string) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'statement) in
    Obj.repr(
# 720 "jc/jc_parser.mly"
   ( locate_statement (JCPStry(_2,[(_4,_5,_6)],skip)) )
# 2090 "jc/jc_parser.ml"
               : 'exception_statement))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'type_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'parameters) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 729 "jc/jc_parser.mly"
    ( locate_decl (JCPDlogic(Some _2, _3, _4, _6)) )
# 2100 "jc/jc_parser.ml"
               : 'logic_definition))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'parameters) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'expression) in
    Obj.repr(
# 731 "jc/jc_parser.mly"
    ( locate_decl (JCPDlogic(None, _2, _3, _5)) )
# 2109 "jc/jc_parser.ml"
               : 'logic_definition))
(* Entry file *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
|]
let yytables =
  { Parsing.actions=yyact;
    Parsing.transl_const=yytransl_const;
    Parsing.transl_block=yytransl_block;
    Parsing.lhs=yylhs;
    Parsing.len=yylen;
    Parsing.defred=yydefred;
    Parsing.dgoto=yydgoto;
    Parsing.sindex=yysindex;
    Parsing.rindex=yyrindex;
    Parsing.gindex=yygindex;
    Parsing.tablesize=yytablesize;
    Parsing.table=yytable;
    Parsing.check=yycheck;
    Parsing.error_function=parse_error;
    Parsing.names_const=yynames_const;
    Parsing.names_block=yynames_block }
let file (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 1 lexfun lexbuf : Jc_ast.pdecl list)
